import random
import copy

_shape_description = {"shape": "pendant",
                      "division_patterns": [],
                      "division_offsets": [],
                      "division_radii": [],
                      "radius": 1.0,
                      "height": 1.0,
                      "fixture_radius": 0.3,
                      "style": "dark"}

_styles = {"dark" : {"shade": (0.1, 0.1, 0.1),
            "chord": (0.05, 0.05, 0.05),
            "base": (0.05, 0.05, 0.05),
            "use_wall": True,
            "wall": (0.9, 0.9, 0.9)},
           "billard": {"shade": (0.1, 0.1, 0.1),
            "chord": (0.05, 0.05, 0.05),
            "base": (0.05, 0.05, 0.05),
            "use_wall": True,
            "wall": (0.9, 0.9, 0.9)},
           "light": {"shade": (0.1, 0.1, 0.1),
            "chord": (0.05, 0.05, 0.05),
            "base": (0.05, 0.05, 0.05),
            "use_wall": True,
            "wall": (0.9, 0.9, 0.9)},             
           }

_division_types = ["straight",
                   "square",
                   "inv_square",
                   "sine",
                   "inv_sine",
                   "ramp",
                   "inv_ramp"]


def get_random_shape_description(shape, bbox, feature_min):
    
    """
    Generate a random shape description and style
    """
    
    shape_description = copy.deepcopy(_shape_description)
    shape_description["shape"] = shape
    
    max_divisions = 5
    num_divisions = int(1 + random.random()*(max_divisions-1))
    num_divisions = 4
    
    remaining_offset = 1.0
    feature_height = feature_min[1] + random.random()*(bbox[1]-feature_min[1])
    feature_radius = feature_min[0] + random.random()*(bbox[0]-feature_min[0])
    shape_description["height"] = feature_height
    shape_description["radius"] = feature_radius
    
    min_radius_fraction = feature_min[0]/feature_radius
    for idx in range(num_divisions):
        shape_description["division_patterns"].append(random.choice(_division_types))
        
        offset = 1.0/num_divisions
        #offset = random.random()*remaining_offset
        remaining_offset -= offset
        shape_description["division_offsets"].append(offset)
        radius_fraction = min_radius_fraction+random.random()*(1.0-min_radius_fraction)
        shape_description["division_radii"].append(radius_fraction)
    shape_description["style"] = random.choice(list(_styles.keys()))
    shape_description["division_radii"].sort()
    return shape_description